#include "main.h"
#include "globals.h"

DIPSWITCH   dipswitch[MAX_DIPS];

void readdip(void)
{
   int i,j;
   BYTE inidx;
   FILE *fdip;
   static char buffer[256];
//default
   memcpy(dipswitch,pBoard->dipsetting,sizeof(DIPSWITCH)*MAX_DIPS);
//file
   sprintf(buffer,"dips\\%s.dip",pBoard->name);
   fdip=fopen(buffer,"rb");
   if(fdip)
   {
      for(i=0;i<MAX_DIPS;i++)
      {
         for(j=0;j<8;j++)
         {
            cleardipset(i,j);
            fread(&inidx,1,1,fdip);
            dipswitch[i].dipsetting[j].valuesetting[inidx].thisvalue=1;
         }
      }
      fclose(fdip);
   }

   updatedip();
}

void writedip(void)
{
   FILE *fdip;
   int i,j,k;
   BYTE outidx;
   static char buffer[256];
   sprintf(buffer,"dips\\%s.dip",pBoard->name);
   fdip=fopen(buffer,"wb");
   if(fdip)
   {
      for(i=0;i<MAX_DIPS;i++)
      {
         for(j=0;j<8;j++)
         {
            outidx=0;
            for(k=0;k<16;k++)
            {
               if(dipswitch[i].dipsetting[j].valuesetting[k].thisvalue)
               {
                  outidx=(BYTE)k;
                  break;
               }
            }
            fwrite(&outidx,1,1,fdip);
         }
      }
      fclose(fdip);
   }
}

void updatedip(void)
{
   int i,j,k,outval;
   for(i=0;i<MAX_DIPS;i++)
   {
      dipswitch[i].setting=dipswitch[i].basevalue;
      if(!dipswitch[i].id)
         break;
      for(j=0;j<32;j++)
      {
         if(!*dipswitch[i].dipsetting[j].szName)
            break;

         outval=dipswitch[i].dipsetting[j].defsetting;
         for(k=0;k<16;k++)
         {
            if(!*dipswitch[i].dipsetting[j].valuesetting[k].szValue)
               break;
            if(dipswitch[i].dipsetting[j].valuesetting[k].thisvalue)
            {
               outval=dipswitch[i].dipsetting[j].valuesetting[k].nValue;
               break;
            }
         }
         dipswitch[i].dipsetting[j].cursetting=outval;
         dipswitch[i].setting|=dipswitch[i].dipsetting[j].cursetting;


         for(k=0;k<16;k++)
         {
            if(!*dipswitch[i].dipsetting[j].valuesetting[k].szValue)
               break;
            if(dipswitch[i].dipsetting[j].valuesetting[k].nValue==outval)
            {
               dipswitch[i].dipsetting[j].valuesetting[k].thisvalue=1;
               break;
            }
         }

      }
   }
}

void cleardipset(int dip,int dipsub)
{
   int i;
   for(i=0;i<16;i++)
   {
      if(!*dipswitch[dip].dipsetting[dipsub].valuesetting[i].szValue)
         break;
      dipswitch[dip].dipsetting[dipsub].valuesetting[i].thisvalue=0;
   }
}

UINT8 dip1(UINT32 offset, struct MemoryReadByte *mrb)
{
   UINT8 retval;


   if(dipswitch[0].force)
      retval=0;
   else
      retval=pCode[offset];


   if(dipswitch[0].exfunc)
      retval|=dipswitch[0].exfunc();


   retval|=dipswitch[0].setting;
   return retval;
}

UINT8 dip2(UINT32 offset, struct MemoryReadByte *mrb)
{
   UINT8 retval;

   if(dipswitch[1].force)
      retval=0;
   else
      retval=pBaseCode[CurrentCPU][offset];

   if(dipswitch[1].exfunc)
      retval|=dipswitch[1].exfunc();

   return retval|dipswitch[1].setting;
}

UINT8 dip3(UINT32 offset, struct MemoryReadByte *mrb)
{
   UINT8 retval;

   if(dipswitch[2].force)
      retval=0;
   else
      retval=pBaseCode[CurrentCPU][offset];

   if(dipswitch[2].exfunc)
      retval|=dipswitch[2].exfunc();

   retval|=dipswitch[2].setting;

   return retval;
}

UINT8 dip4(UINT32 offset, struct MemoryReadByte *mrb)
{
   UINT8 retval;

   if(dipswitch[3].force)
      retval=0;
   else
      retval=pBaseCode[CurrentCPU][offset];

   if(dipswitch[3].exfunc)
      retval|=dipswitch[3].exfunc();

   return retval|dipswitch[3].setting;
}


UINT16 portdip1(UINT16 offset, struct z80PortRead *zpr)
{
   UINT16 retval=0;

   if(dipswitch[0].exfunc)
      retval=dipswitch[0].exfunc();

   return retval|dipswitch[0].setting;

}

UINT16 portdip2(UINT16 offset, struct z80PortRead *zpr)
{
   UINT16 retval=0;

   if(dipswitch[1].exfunc)
      retval=dipswitch[1].exfunc();

   return retval|dipswitch[1].setting;

}

UINT16 portdip3(UINT16 offset, struct z80PortRead *zpr)
{
   UINT16 retval=0;

   if(dipswitch[2].exfunc)
      retval=dipswitch[2].exfunc();

   return retval|dipswitch[2].setting;
}

UINT16 portdip4(UINT16 offset, struct z80PortRead *zpr)
{
   UINT16 retval=0;

   if(dipswitch[3].exfunc)
      retval=dipswitch[3].exfunc();

   return retval|dipswitch[3].setting;
}
