#ifndef _DIP_H_
#define _DIP_H_

#define  MAX_DIPS    4

//common dip switch strings
//lives
#define DIP_LIVES       "Lives"
#define DIP_BONUS       "Bonus Life"
//cabinet
#define DIP_CABINET     "Cabinet"
#define DIP_UPRIGHT     "Upright"
#define DIP_COCKTAIL    "Cocktail"
#define DIP_FLIP        "Flip Screen"

//coins
#define DIP_CREDIT      "Credit"
#define DIP_COINA       "Coin A"
#define DIP_COINB       "Coin B"
#define DIP_1C_1C       "1Coin/1Credit"
#define DIP_1C_2C       "1Coin/2Credits"
#define DIP_1C_3C       "1Coins/3Credits"
#define DIP_1C_4C       "1Coins/4Credits"
#define DIP_1C_5C       "1Coins/5Credits"
#define DIP_1C_6C       "1Coins/6Credits"
#define DIP_1C_7C       "1Coins/7Credits"
#define DIP_1C_8C       "1Coins/8Credits"
#define DIP_2C_1C       "2Coins/1Credit"
#define DIP_2C_2C       "2Coins/2Credits"
#define DIP_2C_3C       "2Coins/3Credits"
#define DIP_2C_4C       "2Coins/4Credits"
#define DIP_2C_5C       "2Coins/5Credits"
#define DIP_2C_6C       "2Coins/7Credits"
#define DIP_2C_7C       "2Coins/8Credits"
#define DIP_2C_8C       "2Coins/8Credits"
#define DIP_3C_1C       "3Coins/1Credit"
#define DIP_3C_2C       "3Coins/2Credits"
#define DIP_3C_4C       "3Coins/4Credits"
#define DIP_4C_1C       "4Coins/1Credit"
#define DIP_4C_3C       "4Coins/3Credits"
#define DIP_5C_1C       "5Coins/1Credit"
#define DIP_FREE        "FreePlay"

//modes
#define DIP_SERVICE     "Service Mode"
#define DIP_ON          "On"
#define DIP_OFF         "Off"
#define DIP_DIFFICULTY  "Diffculty"
#define DIP_SOUNDS      "Demo Sounds"
#define DIP_EASIEST     "Easiest"
#define DIP_EASIER      "Easier"
#define DIP_EASY        "Easy"
#define DIP_NORMAL      "Normal"
#define DIP_MEDIUM      "Medium"
#define DIP_DIFFICULT   "Difficult"
#define DIP_VERY_DIFF   "Very Diff."
#define DIP_HARD        "Hard"
#define DIP_HARDEST     "Hardest"
#define DIP_FREEZE      "Freeze"
#define DIP_RACK        "Rack Test"

typedef struct valusettingTAG
{
   char szValue[32];
   BYTE thisvalue;
   BYTE nValue;
} VALUESETTING;

typedef struct dipsettingTAG
{
   char szName[16];
   BYTE defsetting;
   BYTE cursetting;
   VALUESETTING valuesetting[16];
} DIPSETTING;

typedef struct dipswitchTAG
{
   BYTE id;
   BYTE setting;
   BYTE basevalue;
   UINT8 (*exfunc)(void);
   BYTE force;
   DIPSETTING dipsetting[8];
} DIPSWITCH;

typedef DIPSWITCH *pDIPSWITCH;

void readdip(void);
void writedip(void);
void updatedip(void);
void cleardipset(int dip,int dipsub);

UINT8 dip1(UINT32 offset, struct MemoryReadByte *mrb);
UINT8 dip2(UINT32 offset, struct MemoryReadByte *mrb);
UINT8 dip3(UINT32 offset, struct MemoryReadByte *mrb);
UINT8 dip4(UINT32 offset, struct MemoryReadByte *mrb);

UINT16 portdip1(UINT16 offset, struct z80PortRead *zpr);
UINT16 portdip2(UINT16 offset, struct z80PortRead *zpr);
UINT16 portdip3(UINT16 offset, struct z80PortRead *zpr);
UINT16 portdip4(UINT16 offset, struct z80PortRead *zpr);

#endif
