#ifndef _GAL_MEM_H_
#define _GAL_MEM_H_

struct z80PortRead ReadPorts[] =
{
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};

struct z80PortWrite WritePorts[] =
{
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};

struct MemoryWriteByte GameWrite[] =
{
   {0x0000,0x27ff,romwrite,NULL},
   {0x6004,0x6007,backlfo,NULL},
   {0x6800,0x6800,lfoon,NULL},
   {0x6803,0x6803,deathw,NULL},
   {0x6805,0x6805,shootw,NULL},
   {0x6807,0x6807,galvolw,NULL},
   {0x7006,0x7006,flipscreenw,NULL},
   {0x7800,0x7800,galpitchw,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};


struct MemoryWriteByte UniGameWrite[] =
{
   {0x0000,0x27ff,romwrite,NULL},
   {0x6004,0x6007,backlfo,NULL},
   {0x6800,0x6800,lfoon,NULL},
   {0x6002,0x6002,unigfxbankw,NULL},
   {0x6803,0x6803,deathw,NULL},
   {0x6805,0x6805,shootw,NULL},
   {0x6807,0x6807,galvolw,NULL},
   {0x7006,0x7006,flipscreenw,NULL},
   {0x7800,0x7800,galpitchw,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryWriteByte PacblGameWrite[] =
{
   {0x0000,0x27ff,romwrite,NULL},
   {0x6004,0x6007,backlfo,NULL},
   {0x6800,0x6800,lfoon,NULL},
   {0x6803,0x6803,deathw,NULL},
   {0x6805,0x6805,shootw,NULL},
   {0x6807,0x6807,galvolw,NULL},
   {0x7006,0x7006,ivflipscreenw,NULL},
   {0x7800,0x7800,galpitchw,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryReadByte GameRead[] =
{
   {0x6000,0x6000,dip2,NULL},
   {0x6800,0x6800,dip3,NULL},
   {0x7000,0x7000,dip1,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryReadByte GalPXGameRead[] =
{
   {0x6000,0x6000,dip2,NULL},
   {0x6800,0x6800,dip3,NULL},
   {0x7000,0x7000,dip1,NULL},
   {0x7800,0x78ff,galpxtitle,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};


struct MemoryReadByte PacblGameRead[] =
{
   {0x6800,0x6800,dip1,NULL},
   {0x7000,0x7000,dip2,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryWriteByte ZigZagWrite[] =
{
   {0x0000,0x3fff,romwrite,NULL},
   {0x4800,0x4800,romwrite,NULL},
   {0x4801,0x4801,zigzagdataw,NULL},
   {0x4803,0x4803,zigzagcontrolw,NULL},
   {0x4900,0x49ff,zigzaglatchw,NULL},
   {0x4a00,0x4a00,romwrite,NULL},
   {0x7002,0x7002,zigzagprotw,NULL},
   {0x7006,0x7006,flipscreenw,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryReadByte ZigZagRead[]=
{
   {0x4800,0x4fff,nopread,NULL},
   {0x6800,0x6800,dip1,NULL},
   {0x7000,0x7000,dip2,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryWriteByte JumpBugWrite[] =
{
   {0x0000,0x3fff,romwrite,NULL},
   {0x4c00,0x4fff,jumpbugmirw,NULL},
   {0x5800,0x5800,memAY8910_write_port_0_w,NULL},
   {0x5900,0x5900,memAY8910_control_port_0_w,NULL},
   {0x6002,0x6006,jumpbuggfxbankw,NULL},
   {0xfff0,0xffff,romwrite,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryReadByte JumpBugRead[]=
{
   {0x4c00,0x4fff,checkmanmir,NULL},
   {0x6000,0x6000,dip1,NULL},
   {0x6800,0x6800,dip2,NULL},
   {0x7000,0x7000,dip3,NULL},
   {0xb000,0xbfff,jumpbugprot,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryReadByte LeversRead[]=
{
   {0x4c00,0x4fff,checkmanmir,NULL},
   {0x7000,0x7000,dip1,NULL},
   {0xb000,0xbfff,jumpbugprot,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryWriteByte OrbitronWrite[]=
{
   {0x0000,0x27ff,romwrite,NULL},
   {0x6004,0x6007,backlfo,NULL},
   {0x6800,0x6800,lfoon,NULL},
   {0x6803,0x6803,deathw,NULL},
   {0x6805,0x6805,shootw,NULL},
   {0x6807,0x6807,galvolw,NULL},
   {0x7006,0x7006,ivflipscreenw,NULL},
   {0x7800,0x7800,galpitchw,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryReadByte OrbitronRead[]=
{
   {0x6800,0x6800,dip1,NULL},
   {0x7000,0x7000,dip2,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

#endif
