#include "main.h"
#include "galvid.h"
#include "globals.h"
#include "twk.h"
#include "blit.h"
#include "ui.h"
#include <time.h>


int jbugbank2;
int jbugmodchar;
int unimodchar;
static int jumpbuggfxbank[5];
//shows dirty updates (coloured blocks)
//#define dirtycheck
static BYTE zigbucket1[0x1000];
static BYTE zigbucket2[0x1000];
int backcolor=0;
static int unigfxbank=0;
extern int gfxext;
int blnkchar;
int maxchar;
int startchar;
int starsblink=0;
int colmask=7;
int bankchar=0;
int transcol=0;
int bucket1;
int bucket2;

int background=1;
int zigzagswap=0;
int setbyui=0;
void (*sprmodify)(int *sprtomod);

STARS stars[MAX_STARS];
pBYTE starrub[MAX_STARS];

static STARS blinkvals[]=
{
   {255,255,1},
   {255,255,4},
   {4,255,255},
   {255,255,255}
};


void initgal(void)
{
   precalcstars();
   blnkchar=16;
   maxchar=32;
   startchar=0;
   pCharMem=&pCode[0x5000];
   pAttrMem=&pCode[0x5800];
   memcpy(zigbucket1,&pCode[0x2000],0x1000);
   memcpy(zigbucket2,&pCode[0x3000],0x1000);
   sprmodify=donothingmod;
}

void inituni(void)
{
   precalcstars();
   blnkchar=16;
   maxchar=32;
   startchar=0;
   pCharMem=&pCode[0x5000];
   pAttrMem=&pCode[0x5800];
   sprmodify=unisprmod;
}


void inithotshock(void)
{
   precalcstars();
   blnkchar=16;
   maxchar=32;
   startchar=0;
   pCharMem=&pCode[0x4800];
   pAttrMem=&pCode[0x5000];
   sprmodify=unisprmod;
   pCode[0x2ef9]=0xc9;
}


void initjumpbug(void)
{
   precalcstars();
   blnkchar=16;
   maxchar=32;
   startchar=0;
   pCharMem=&pCode[0x4800];
   pAttrMem=&pCode[0x5000];
   memcpy(zigbucket1,&pCode[0x2000],0x1000);
   memcpy(zigbucket2,&pCode[0x3000],0x1000);
   sprmodify=jumpbugmod;
}

void donothingmod(int *spr)
{
   (*spr)&=0x3f;
}

void unisprmod(int *spr)
{
   (*spr)&=0x3f;
   (*spr)|=unigfxbank<<6;
}


void mcrstmod(int *spr)
{
   (*spr)&=0x3f;
   if((gfxext&4)&&(*spr&0x30)==0x20)
      *spr=(*spr&0x0f)|(gfxext<<4);
}



void jumpbugmod(int *spr)
{
   (*spr)&=0x3f;
   if(((*spr&0x30)==0x20)&&jumpbuggfxbank[2])
      *spr+=32+(jumpbuggfxbank[0]<<4)+(jumpbuggfxbank[1]<<5)+((~jumpbuggfxbank[4]&1)<<6);
}


void cleargal(void)
{
}


void galint(void)
{
   if(pCode[0x7001])
      mz80nmi();
}



void ramwrite(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   pBaseCode[CurrentCPU][offset]=value;
}

void ramwrite2(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   loginfo("RAM Write to 0x%x (0x%x)",offset,value);
   pBaseCode[CurrentCPU][offset]=value;
}

UINT8 ramread(UINT32 offset, struct MemoryReadByte *mrb)
{
//   loginfo("RAM Read from 0x%x (0x%x)",offset,pBaseCode[CurrentCPU][offset]);
   return pBaseCode[CurrentCPU][offset];
}

void bothwrite(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
//   loginfo("Both Write to 0x%x (0x%x)",offset,value);
   pBaseCode[CurrentCPU][offset]=value;
   context[CurrentCPU].z80Base[offset]=value;
}

void romwrite2(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{

   loginfo("TRAP write current CPU %d , offset =0x%x , value =0x%x , pc = 0x%x",
               CurrentCPU,offset,value,mz80GetRegisterValue(NULL,CPUREG_PC));

   return;
}

void unigfxbankw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   unigfxbank=value&1;
}


UINT8 nopread(UINT32 offset, struct MemoryReadByte * mrb)
{
   return 0;
}

UINT8 galpxtitle(UINT32 offset, struct MemoryReadByte *mrb)
{
   return 0xff;
}

void romwrite(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   return;
}



void updatescreen(void)
{
#ifdef dirtycheck
fastclear();
#endif

   clearstars();
   galdispchars();

   drawbullets();

   drawsprites(0x5840,32);
   if(pCode[0x7004]&1)
      drawstars(TRUE,FALSE);

}

void zigupdatescreen(void)
{
   galdispchars();
   drawsprites(0x5840,64);
}

void pacblupdatescreen(void)
{
   galdispchars();
   drawsprites(0x5840,32);
}

void jumpbugupdatescreen(void)
{

   jbugbank2=jumpbuggfxbank[2];
   jbugmodchar=0x80+((*jumpbuggfxbank<<6)+(jumpbuggfxbank[1]<<7)+((~jumpbuggfxbank[4]&1)<<8));
   clearstars();
   jbugdispchars();
   drawsprites(0x5040,32);
   if(pCode[0x7004]&1)
      drawstars(TRUE,FALSE);

}

void updatehotshockscreen(void)
{
   unimodchar=(unigfxbank<<8);
   unidispchars();
   drawbullets();
   drawsprites(0x5040,32);
}


void uniupdatescreen(void)
{
#ifdef dirtycheck
fastclear();
#endif

   clearstars();
   unimodchar=(unigfxbank<<8);
   unidispchars();


   drawbullets();

   drawsprites(0x5840,32);
   if(pCode[0x7004]&1)
      drawstars(TRUE,FALSE);

}

void drawnoflipsprites(int spridx,int nospr)
{
   int idx,spr,check;
   BYTE col;
   pBYTE pWork;
   int x,y;


   pWork=&pCode[spridx];
   if(realorient)
   {
      for(idx=0;idx<nospr;idx+=4)
      {
         if(FlipScreen)
         {
            y=pWork[idx];
            x=240-pWork[3+idx];
            check=(x<232&&y<224);
         }
         else
         {
            y=240-pWork[idx];
            x=pWork[3+idx]+1;
            check=(x>8&&y>8);
         }
         spr=pWork[1+idx];


         if(check&&spr)
         {
            markgaldirty(262-y,x,2);
            col=pWork[2+idx]&0x07;
            sprblit(x,y,spr,col,0,0);
         }
      }
   }
   else
   {
      for(idx=0;idx<nospr;idx+=4)
      {
         if(FlipScreen)
         {
            x=248-pWork[idx];
            y=240-pWork[3+idx];
            check=(x<240&&y<232);
         }
         else
         {
            x=pWork[idx]+7;
            y=pWork[3+idx];
            check=(x>8&&y>8);
         }

         spr=pWork[1+idx];
         if(check&&spr)
         {
            markgaldirty(x,y,2);

            col=pWork[2+idx]&0x07;

            sprblit(x,y,spr,col,0,0);
         }
      }
   }
}

void drawsprites(int spridx,int nospr)
{
   int idx,spr,check;
   BYTE col;
   pBYTE pWork;
   int x,y,flipx,flipy;


   pWork=&pCode[spridx];
   if(realorient)
   {
      for(idx=0;idx<nospr;idx+=4)
      {
         if(FlipScreen)
         {
            y=pWork[idx];
            x=240-pWork[3+idx];
            check=(x<232&&y<224);
         }
         else
         {
            y=240-pWork[idx];
            x=pWork[3+idx]+1;
            check=(x>8&&y>8);
         }
         spr=pWork[1+idx];


         if(check&&spr)
         {
            markgaldirty(262-y,x,2);
            col=pWork[2+idx]&0x07;
            flipx=(spr>>6)&1;
            flipy=(spr>>6)&2;
            sprmodify(&spr);

            if(FlipScreen)
            {
               flipx=!flipx;
               flipy=!flipy;
            }
            sprblit(x,y,spr,col,flipx,flipy);
         }
      }
   }
   else
   {
      for(idx=0;idx<nospr;idx+=4)
      {
         if(FlipScreen)
         {
            x=248-pWork[idx];
            y=240-pWork[3+idx];
            check=(x<240&&y<232);
         }
         else
         {
            x=pWork[idx]+7;
            y=pWork[3+idx];
            check=(x>8&&y>8);
         }

         spr=pWork[1+idx];
         if(check&&spr)
         {
            markgaldirty(x,y,2);

            col=pWork[2+idx]&0x07;
            flipx=(spr>>6)&2;
            flipy=(spr>>6)&1;


            sprmodify(&spr);
            if(FlipScreen)
            {
               flipx=!flipx;
               flipy=!flipy;
            }

            sprblit(x,y,spr,col,flipx,flipy);
         }
      }
   }
}


void drawbullets(void)
{
   int index;
   int x,y,col,y1;
   pBYTE pWork;

   if(realorient)
   {
      for(index=0;index<32;index+=4)
      {
         if (index<22)
            col=25;
         else
            col=7;
         if(FlipScreen)
         {
            if(ror)
            {
               y=pCode[0x5861+index];
               x=pCode[0x5863+index]+1;
            }
            else
            {
               y=pCode[0x5861+index];
               x=251-pCode[0x5863+index];
            }
         }
         else
         {
            if(ror)
            {
               y=255-pCode[0x5861+index];
               x=pCode[0x5863+index]+2;
            }
            else
            {
               y=255-pCode[0x5861+index];
               x=252-pCode[0x5863+index];
            }
         }

         if(x>31&&x<255)
         {
            markgaldirty(262-y,x,1);
            x+=32;
            y+=32;

            pWork=pScreen+x+(y<<9);
            memset(pWork,col,3);
         }
      }
   }
   else
   {
      for(index=0;index<32;index+=4)
      {
         if (index<22)
            col=25;
         else
            col=7;

         if(FlipScreen)
         {
            if(flipxy)
            {
               x=262-pCode[0x5861+index];
               y=pCode[0x5863+index]+1;
            }
            else
            {
               x=262-pCode[0x5861+index];
               y=(251-pCode[0x5863+index]);
            }
         }
         else
         {
            if(flipxy)
            {
               y=pCode[0x5863+index]+2;
               x=7+pCode[0x5861+index];
            }
            else
            {
               y=(252-pCode[0x5863+index]);
               x=7+pCode[0x5861+index];
            }
         }


         if(y>31)
         {
            markgaldirty(x,y,1);
            x+=32;
            y+=32;
            pWork=pScreen+x+(y<<9);

            for(y1=0;y1<3;pWork+=512,y1++)
               *pWork=col;
         }
      }
   }
}

static inline void markgaldirty(int x,int y,int type)
{
   int row,i;
   int shiftout[3];
   BYTE rowoff,basex,finbase;
   y&=255;

   if(FlipScreen)
   {
      row=((255-y)>>3);
      basex=x-7;
//offset for row(s)
      for(i=0;i<type+1;i++)
      {
         rowoff=pAttrMem[((row-i)&31)<<1];
         finbase=(basex+rowoff);
         shiftout[i]=(finbase>>3);
      }

   }
   else
   {
      row=((y)>>3);
      basex=(262-x);
//offset for row(s)
      for(i=0;i<type+1;i++)
      {
         rowoff=pAttrMem[((row+i)&31)<<1];
         finbase=(basex+rowoff);
         shiftout[i]=(finbase>>3);
      }

   }


   pacdirty[row+(shiftout[0]<<5)]=-1;
   switch(type)
   {
      case 2:

         if(FlipScreen)
         {
            pacdirty[((row-1)&31)+(shiftout[1]<<5)]=-1;
            pacdirty[((row-2)&31)+(shiftout[2]<<5)]=-1;

            if(realorient)
            {
               pacdirty[row+(((shiftout[0]-1)&31)<<5)]=-1;
               pacdirty[((row-1)&31)+(((shiftout[1]-1)&31)<<5)]=-1;
               pacdirty[((row-2)&31)+(((shiftout[2]-1)&31)<<5)]=-1;

               pacdirty[row+(((shiftout[0]-2)&31)<<5)]=-1;
               pacdirty[((row-1)&31)+(((shiftout[1]-2)&31)<<5)]=-1;
               pacdirty[((row-2)&31)+(((shiftout[2]-2)&31)<<5)]=-1;
            }
            else
            {
               pacdirty[row+(((shiftout[0]+1)&31)<<5)]=-1;
               pacdirty[((row-1)&31)+(((shiftout[1]+1)&31)<<5)]=-1;
               pacdirty[((row-2)&31)+(((shiftout[2]+1)&31)<<5)]=-1;

               pacdirty[row+(((shiftout[0]+2)&31)<<5)]=-1;
               pacdirty[((row-1)&31)+(((shiftout[1]+2)&31)<<5)]=-1;
               pacdirty[((row-2)&31)+(((shiftout[2]+2)&31)<<5)]=-1;

            }
         }
         else
         {
            pacdirty[row+1+(shiftout[1]<<5)]=-1;
            pacdirty[row+2+(shiftout[2]<<5)]=-1;

            if(realorient)
            {
               pacdirty[row+(((shiftout[0]+1)&31)<<5)]=-1;
               pacdirty[row+1+(((shiftout[1]+1)&31)<<5)]=-1;
               pacdirty[row+2+(((shiftout[2]+1)&31)<<5)]=-1;

               pacdirty[row+(((shiftout[0]+2)&31)<<5)]=-1;
               pacdirty[row+1+(((shiftout[1]+2)&31)<<5)]=-1;
               pacdirty[row+2+(((shiftout[2]+2)&31)<<5)]=-1;
            }
            else
            {
               pacdirty[row+(((shiftout[0]-1)&31)<<5)]=-1;
               pacdirty[row+1+(((shiftout[1]-1)&31)<<5)]=-1;
               pacdirty[row+2+(((shiftout[2]-1)&31)<<5)]=-1;

               pacdirty[row+(((shiftout[0]-2)&31)<<5)]=-1;
               pacdirty[row+1+(((shiftout[1]-2)&31)<<5)]=-1;
               pacdirty[row+2+(((shiftout[2]-2)&31)<<5)]=-1;
            }
         }


         break;
      case 1:
         if(FlipScreen)
            pacdirty[((row-1)&31)+(shiftout[1]<<5)]=-1;
         else
            pacdirty[row+1+(shiftout[1]<<5)]=-1;

   }
}

void clearstars(void)
{
   int idx;

   for(idx=0;idx<MAX_STARS;idx++)
   {
      if(starrub[idx]==(pBYTE)-1)
         break;
      *starrub[idx]=0;
   }
   starrub[0]=(pBYTE)-1;
}

void drawstars(int scroll,int checkb)
{
   int idx,starshift;
   int rubout=0;
   pBYTE pWork;

   if(!background)
      return;

   if(scroll)
   {
      if(realorient)
      {
         if(FlipScreen)
         {

            for(idx=0;idx<MAX_STARS;idx++)
            {
               starshift=(stars[idx].x-staroff)&511;
               if(starshift<288&&stars[idx].y<240)
               {
                  if ((stars[idx].y&1)^((starshift>>4)&1))
                  {
                     pWork=pScreen+starshift+32+((stars[idx].y+32)<<9);
                     if(!*pWork)
                     {
                        starrub[rubout++]=pWork;
                        *pWork=stars[idx].col;
                     }
                  }
               }
            }
         }
         else
         {
            for(idx=0;idx<MAX_STARS;idx++)
            {
               starshift=(stars[idx].x+staroff)&511;
               if(starshift<288&&stars[idx].y<240)
               {
                  if ((stars[idx].y&1)^((starshift>>4)&1))
                  {
                     pWork=pScreen+starshift+32+((stars[idx].y+32)<<9);
                     if(!*pWork)
                     {
                        starrub[rubout++]=pWork;
                        *pWork=stars[idx].col;
                     }
                  }
               }
            }
         }
      }
      else
      {
         if(FlipScreen)
         {
            for(idx=0;idx<MAX_STARS;idx++)
            {
               starshift=(stars[idx].x-staroff)&511;
               if(stars[idx].y<240&&starshift<288)
               {
                  if ((stars[idx].y&1)^((starshift>>4)&1))
                  {

                     pWork=pScreen+stars[idx].y+32+((starshift+32)<<9);
                     if(!*pWork)
                     {
                        *pWork=stars[idx].col;
                        starrub[rubout++]=pWork;
                     }
                  }
               }
            }
         }
         else
         {
            for(idx=0;idx<MAX_STARS;idx++)
            {
               starshift=(stars[idx].x+staroff)&511;
               if(stars[idx].y<240&&starshift<288)
               {
                  if ((stars[idx].y&1)^((starshift>>4)&1))
                  {

                     pWork=pScreen+stars[idx].y+32+((starshift+32)<<9);
                     if(!*pWork)
                     {
                        *pWork=stars[idx].col;
                        starrub[rubout++]=pWork;
                     }
                  }
               }
            }
         }
      }
   }
   else
   {
      if(realorient)
      {
         if(checkb)
         {
            for(idx=0;idx<MAX_STARS;idx++)
            {
               if((stars[idx].x>>1)<255&&stars[idx].y<288)
               {
                  if((stars[idx].col&blinkvals[starsblink].col)&&
                        (stars[idx].x&blinkvals[starsblink].x))
                  {
                     pWork=pScreen+(stars[idx].x>>1)+32+((stars[idx].y+32)<<9);
                     if(!*pWork)
                     {
                        *pWork=stars[idx].col;
                     }
                  }
               }
            }
         }
         else
         {
            for(idx=0;idx<MAX_STARS;idx++)
            {
               if((stars[idx].x>>1)<255&&stars[idx].y<288)
               {
                  if((stars[idx].col&blinkvals[starsblink].col)&&
                        (stars[idx].x&blinkvals[starsblink].x))
                  {
                     pWork=pScreen+(stars[idx].x>>1)+32+((stars[idx].y+32)<<9);
                     *pWork=stars[idx].col;
                  }
               }
            }
         }
      }
      else
      {
         if(checkb)
         {
            for(idx=0;idx<MAX_STARS;idx++)
            {
               if((stars[idx].x)<288&&stars[idx].y<240)
               {
                  if((stars[idx].col&blinkvals[starsblink].col)&&
                        (stars[idx].y&blinkvals[starsblink].y))
                  {
                     pWork=pScreen+stars[idx].y+32+((stars[idx].x+32)<<9);

                     if(!*pWork)
                        *pWork=stars[idx].col;
                  }
               }
            }
         }
         else
         {
            for(idx=0;idx<MAX_STARS;idx++)
            {
               if((stars[idx].x)<288&&stars[idx].y<240)
               {
                  if((stars[idx].col&blinkvals[starsblink].col)&&
                        (stars[idx].y&blinkvals[starsblink].y))
                  {
                     pWork=pScreen+stars[idx].y+32+((stars[idx].x+32)<<9);
                     *pWork=stars[idx].col;
                  }
               }
            }
         }
      }
   }
   starrub[rubout]=(pBYTE)-1;
}

void precalcstars(void)
{
   int total_stars,generator,x,y;

	total_stars = 0;
	generator = 0;
   starrub[0]=(pBYTE)-1;
   for(y=255;y>=0;y--)
	{
      for(x=511;x>=0;x--)
		{
			int bit1,bit2;


			generator <<= 1;
			bit1 = (~generator >> 17) & 1;
			bit2 = (generator >> 5) & 1;

			if (bit1 ^ bit2) generator |= 1;

			if (((~generator >> 16) & 1) && (generator & 0xff) == 0xff)
			{
				int color;

				color = (~(generator >> 8)) & 0x3f;
				if (color && total_stars < MAX_STARS)
				{
					stars[total_stars].x = x;
					stars[total_stars].y = y;
               stars[total_stars].col = color;
					total_stars++;
				}
			}
		}
	}
}

void setpal(pBYTE pIn)
{

   stdsetpal(pIn,32);
//extra blue
   outportb(0x3c8,33);
   outportb(0x3c9,0);
   outportb(0x3c9,0);
   outportb(0x3c9,12);
//extra black
   outportb(0x3c8,34);
   outportb(0x3c9,0);
   outportb(0x3c9,0);
   outportb(0x3c9,0);
//set overscan to extra black rather than 0
//allows us to change game black (colour 0)
   inportb(0x3da);
   outportb(0x3c0,0x11|0x20);
   outportb(0x3c0,34);
//clear VESA screen stuff - to stop the whole screen going blue when the background is on
   clearvesamem(34);

}

void stdsetpal(pBYTE pIn,int totcols)
{
   int idx;
   int bit0,bit1,bit2;
   for(idx=0;idx<totcols;idx++)
   {
      outportb(0x3c8,idx);

//red
      bit0=(*pIn&0x01)*0x21;
      bit1=((*pIn>>1)&0x01)*0x47;
      bit2=((*pIn>>2)&0x01)*0x97;
      outportb(0x3c9,(bit0+bit1+bit2)>>2);
//green
      bit0=((*pIn>>3)&0x01)*0x21;
      bit1=((*pIn>>4)&0x01)*0x47;
      bit2=((*pIn>>5)&0x01)*0x97;
      outportb(0x3c9,(bit0+bit1+bit2)>>2);
//blue
      bit1=((*pIn>>6)&0x01)*0x4f;
      bit2=((*pIn>>7)&0x01)*0xa8;
      outportb(0x3c9,(bit1+bit2)>>2);



      pIn++;
	}

}




void copyspr(pBYTE pIn,pBYTE pOut)
{
   int y;

   for(y=0;y<8;y++)
   {
      memcpy(pOut,pIn,8);
      pOut+=16;
      pIn+=8;
   }
}

void zigzagprotw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{

   if(value)
   {
      if(!zigzagswap)
      {
         fastcopy(&pCode[0x3000],zigbucket1,0x400);
         fastcopy(&pCode[0x2000],zigbucket2,0x400);

      }
      zigzagswap=1;
   }
   else
   {
      if(zigzagswap)
      {
         fastcopy(&pCode[0x2000],zigbucket1,0x400);
         fastcopy(&pCode[0x3000],zigbucket2,0x400);
      }
      zigzagswap=0;
   }
}


//decode encrypted roms - taken from MAME
void initcheckman(void)
{
   precalcstars();
   gfxext=0;
   checkmandecode();
   blnkchar=16;
   maxchar=32;
   startchar=0;
   pCharMem=&pCode[0x9000];
   pAttrMem=&pCode[0x9800];
}

//decode encrypted roms - taken from MAME
void checkmandecode(void)
{
/*
                     Encryption Table
                     ----------------
+---+---+---+------+------+------+------+------+------+------+------+
|A2 |A1 |A0 |D7    |D6    |D5    |D4    |D3    |D2    |D1    |D0    |
+---+---+---+------+------+------+------+------+------+------+------+
| 0 | 0 | 0 |D7    |D6    |D5    |D4    |D3    |D2    |D1    |D0^^D6|
| 0 | 0 | 1 |D7    |D6    |D5    |D4    |D3    |D2    |D1^^D5|D0    |
| 0 | 1 | 0 |D7    |D6    |D5    |D4    |D3    |D2^^D4|D1^^D6|D0    |
| 0 | 1 | 1 |D7    |D6    |D5    |D4^^D2|D3    |D2    |D1    |D0^^D5|
| 1 | 0 | 0 |D7    |D6^^D4|D5^^D1|D4    |D3    |D2    |D1    |D0    |
| 1 | 0 | 1 |D7    |D6^^D0|D5^^D2|D4    |D3    |D2    |D1    |D0    |
| 1 | 1 | 0 |D7    |D6    |D5    |D4    |D3    |D2^^D0|D1    |D0    |
| 1 | 1 | 1 |D7    |D6    |D5    |D4^^D1|D3    |D2    |D1    |D0    |
+---+---+---+------+------+------+------+------+------+------+------+

For example if A2=1, A1=1 and A0=0 then D2 to the CPU would be an XOR of
D2 and D0 from the ROM's. Note that D7 and D3 are not encrypted.

Encryption PAL 16L8 on cardridge
         +--- ---+
    OE --|   U   |-- VCC
 ROMD0 --|       |-- D0
 ROMD1 --|       |-- D1
 ROMD2 --|VER 5.2|-- D2
    A0 --|       |-- NOT USED
    A1 --|       |-- A2
 ROMD4 --|       |-- D4
 ROMD5 --|       |-- D5
 ROMD6 --|       |-- D6
   GND --|       |-- M1 (NOT USED)
         +-------+
Pin layout is such that links can replace the PAL if encryption is not used.

*/
	int A;
	int data_xor=0;



   for(A=0;A<0x2800;A++)
	{
      switch(A&0x07)
		{
         case 0:
            data_xor=(pCode[A]&0x40)>>6;
            break;
         case 1:
            data_xor=(pCode[A] & 0x20)>>4;
            break;
         case 2:
            data_xor=((pCode[A]&0x10)>>2)|((pCode[A]&0x40)>>5);
            break;
         case 3:
            data_xor=((pCode[A]&0x04)<<2)|((pCode[A]&0x20)>>5);
            break;
         case 4:
            data_xor=((pCode[A]&0x10)<<2)|((pCode[A]&0x02)<<4);
            break;
         case 5:
            data_xor=((pCode[A]&0x01)<<6)|((pCode[A]&0x04)<<3);
            break;
         case 6:
            data_xor=(pCode[A]&0x01)<<2;
            break;
         case 7:
            data_xor=(pCode[A]&0x02)<<3;
            break;
		}
      pCode[A]^=data_xor;
	}
}

UINT8 checkmanmir(UINT32 offset, struct MemoryReadByte * mrb)
{
   return pCode[offset-0x400];
}


UINT8 jumpbugmirr(UINT32 offset, struct MemoryReadByte * mrb)
{
   return pCode[offset-0x400];
}

void jumpbugmirw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   pCode[offset-0x0400]=value;
}

void updatecheckmanscr(void)
{
   galdispchars();
   drawsprites(0x9840,32);
}

UINT8 jumpbugprot(UINT32 offset, struct MemoryReadByte * mrb)
{
	switch (offset)
	{
      case 0xb114:
         return 0x4f;
      case 0xb118:
         return 0xd3;
      case 0xb214:
         return 0xcf;
      case 0xb235:
         return 0x02;
      case 0xb311:
         return 0x00;
	}
	return 0;
}

void jumpbuggfxbankw(UINT32 offset, UINT8 value,struct MemoryWriteByte * mwb)
{
   offset-=mwb->lowAddr;
   jumpbuggfxbank[offset]=value&1;
}

