#include "main.h"
#include "twk.h"
#include "invvid.h"
#include "globals.h"

static int shft,shft2,shftamnt;
static int rst[]={0x08,0x10};
static char silookup[0x2000];
static int rstflip;
static int refresh;
int rvpt0=0;

static struct MemoryWriteByte refvid={0x2400,0x3000,NULL,NULL};

extern DIPSWITCH   dipswitch[MAX_DIPS];

void initinv(void)
{
   int x,y;
   pCode[0x10002]=0;
//setup the coloured strips
   memset(silookup,7,0x2000);
   stripe(2,8,2);
   for(x=0;x<9;x++)
      for(y=16;y<134;y++)
         silookup[x+(y<<5)]=2;
   stripe(24,4,4);
}


void intspacephinv(void)
{
   memset(silookup,7,0x2000);
   pCode[0x10002]=0;
}

void invflipw(int value)
{
   value>>=5;
   if(!noflip&&dipswitch[1].setting==1)
   {
      if(ror|flipxy)
         value=!value;
      if(FlipScreen!=value)
      {
         FlipScreen=value;
         refresh=1;
      }
   }
}

void invscrclear(void)
{
   refresh=1;
}

void invupdatescreen(void)
{
   int i;
   if(refresh)
   {
      fastclear();
      for(i=0x2400;i<0x4000;i++)
         invvidw(i,pCode[i],&refvid);
      refresh=0;
   }
}

void initlr(void)
{
   int x,y,col;
   pCode[0x10002]=0;
//setup the coloured strips
   memset(silookup,7,0x2000);
   stripe(2,1,4);
   stripe(3,2,3);
   stripe(5,3,4);
   stripe(8,4,14);
   stripe(12,4,5);
   stripe(16,4,3);
   stripe(20,4,2);
   stripe(24,3,5);
   stripe(27,1,4);

   for(y=0;y<256;y++)
   {
      if(y<72)
         col=3;
      else if(y<152)
         col=2;
         else
            col=14;
         silookup[29+(y<<5)]=col;
      if(y<72)
         col=3;
      else if(y<152)
         col=4;
         else
            col=14;
         silookup[30+(y<<5)]=col;

      col=-1;
      if(y>=72&&y<160)
         col=2;
      if(y>=160)
         col=14;
      if(col>=0)
         silookup[28+(y<<5)]=col;
   }
   for(x=0;x<2;x++)
   {
      for(y=0;y<256;y++)
      {
         if(y<136)
            col=3;
         else if(y<192)
            col=5;
         else
            col=3;
         silookup[x+(y<<5)]=col;
      }
   }
}

void initir(void)
{
   pCode[0x10002]=0;
//setup the coloured strips
   memset(silookup,7,0x2000);
   stripe(0,9,2);
   stripe(24,8,4);
}

void stripe(int spos,int width,int col)
{
   int x,y;
   for(x=spos;x<(spos+width);x++)
      for(y=0;y<256;y++)
         silookup[x+(y<<5)]=col;
}

void clearinv(void)
{
}


void invint(void)
{
   z80intAddr=rst[rstflip];
   mz80int(0xff);
   rstflip=!rstflip;
}

UINT8 inv2plin(void)
{
   return (UINT8)pCode[0x10002];
}


void invvidw(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   int work,dummy1,dummy2,dummy3,dummy4,dummy5;
   BYTE col;


   if(!refresh&&pCode[offset]==value)
      return;

   pCode[offset]=value;


   work=offset-mwb->lowAddr;
   col=silookup[work];

   if(realorient)
   {
      __asm__ __volatile__
      (
         ".align 4 \n"
//setup destination
         "pushl   %%ebx \n"
         "movl    %%eax,%%ebx \n"
         "andl    $0x1f,%%ebx \n"
         "shll    $3,%%ebx \n"
         "cmpb    $1,_FlipScreen \n"
         "je      12f \n"
         "movl    $0xff,%%ecx \n"
         "subl    %%ebx,%%ecx \n"
         "addl    %%ecx,%%edi \n"
         "movl    $223,%%ecx \n"
         "shrl    $5,%%eax \n"
         "subl    %%eax,%%ecx \n"
         "shll    $9,%%ecx \n"
         "addl    %%ecx,%%edi \n"
         "jmp     13f \n"
"12:\n"
         "addl    %%ebx,%%edi \n"
         "shrl    $5,%%eax \n"
         "shll    $9,%%eax \n"
         "addl    %%eax,%%edi \n"

"13:\n"
         "popl    %%ebx \n"
         "cmpb    $0,%%bl \n"
         "je      4f \n"
         "movl    $128,%%ecx \n"
         "cmpb    $1,_FlipScreen \n"
         "jne     1f \n"
         "movl    $1,%%ecx \n"

//blit loop
"1:\n"
         "testb   %%cl,%%bl \n"
         "jz      2f \n"
         "movb    %%dl,(%%edi) \n"
         "jmp     3f \n"
"2:\n"
         "movb    $0,(%%edi) \n"
"3:\n"
         "incl    %%edi \n"
         "cmpb    $1,_FlipScreen \n"
         "jne     14f \n"

         "shll    $1,%%ecx \n"
         "cmpb    $0,%%cl \n"
         "jne     1b \n"
         "jmp     6f \n"
"14:\n"

         "shrl    $1,%%ecx \n"
         "jnz     1b \n"
         "jmp     6f \n"


"4:\n"
         "movl    $2,%%ecx \n"
         "xorl    %%eax,%%eax \n"
"5:\n"
         "movl    %%eax,(%%edi) \n"
         "addl    $4,%%edi \n"
         "loop    5b \n"

"6:\n"
//outputs (clobbered inputs)
         : "=a" (dummy1),
         "=D" (dummy2),
         "=b" (dummy3),
         "=d" (dummy4)
// inputs -
         :"0" (work),
         "1" (pBoard->pScreen),
         "2" (value),
         "3" (col)
// registers modified
         :  "cx","cc", "memory"
      );

   }
   else
   {
      __asm__ __volatile__
      (
         ".align 4 \n"
//setup destination
         "pushl   %%ebx \n"
         "movl    %%eax,%%ebx \n"
         "andl    $0x1f,%%ebx \n"
         "shll    $3,%%ebx \n"
         "movl    $0xff,%%ecx \n"
         "subl    %%ebx,%%ecx \n"
         "cmpb    $1,_FlipScreen \n"
         "jne     9f \n"
         "movl    %%ebx,%%ecx \n"
"9:\n"
         "shll    $9,%%ecx \n"
         "addl    %%ecx,%%edi \n"
         "shrl    $5,%%eax \n"
         "cmpb    $1,_FlipScreen \n"
         "jne     10f \n"
         "movl    $223,%%ebx \n"
         "subl    %%eax,%%ebx \n"
         "addl    %%ebx,%%edi \n"
         "jmp     11f \n"
"10:\n"
         "addl    %%eax,%%edi \n"
"11:\n"
         "popl    %%ebx \n"
         "cmpb    $0,%%bl \n"
         "je      4f \n"
         "movl    $128,%%ecx \n"
         "cmpb    $1,_FlipScreen \n"
         "jne     7f \n"
         "movl    $1,%%ecx \n"
"7:\n"

//blit loop
"1:\n"
         "testb   %%cl,%%bl \n"
         "jz      2f \n"
         "movb    %%dl,(%%edi) \n"
         "jmp     3f \n"
"2:\n"
         "movb    $0,(%%edi) \n"
"3:\n"
         "addl    $512,%%edi \n"
         "cmpb    $1,_FlipScreen \n"
         "jne     8f \n"
         "shll    $1,%%ecx \n"
         "cmpb    $0,%%cl \n"
         "jne     1b \n"
         "jmp     6f \n"
"8:\n"
         "shrl    $1,%%ecx \n"
         "jnz     1b \n"
         "jmp     6f \n"


"4:\n"
         "movl    $8,%%ecx \n"
         "xorl    %%eax,%%eax \n"
"5:\n"
         "movb    %%al,(%%edi) \n"
         "addl    $512,%%edi \n"
         "loop    5b \n"

"6:\n"
//outputs (clobbered inputs)
         : "=a" (dummy1),
         "=D" (dummy2),
         "=b" (dummy3),
         "=d" (dummy4)
// inputs -
         :"0" (work),
         "1" (pBoard->pScreen),
         "2" (value),
         "3" (col)
// registers modified
         :  "cx","cc", "memory"
      );
   }
}
void invportw0(UINT16 offset, UINT8 value, struct z80PortWrite *zpw)
{
   rvpt0=value;
}
//shift amount write
void invportw2(UINT16 offset, UINT8 value, struct z80PortWrite *zpw)
{
   shftamnt=value;
}


void invportw3(UINT16 offset, UINT8 value, struct z80PortWrite *zpw)
{
	static unsigned char Sound = 0;

   if (value & 0x01 && ~Sound & 0x01)
      playsample(0,0,LOOP,DEFAULT_FREQ);

   if (~value & 0x01 && Sound & 0x01)
      stopsample(0);

   if (value & 0x02 && ~Sound & 0x02)
      playsample(1,1,ONE_SHOT,DEFAULT_FREQ);


   if (value & 0x04 && ~Sound & 0x04)
      playsample(2,2,ONE_SHOT,DEFAULT_FREQ);

   if (~value & 0x04 && Sound & 0x04)
      stopsample(2);

   if (value & 0x08 && ~Sound & 0x08)
      playsample(3,3,ONE_SHOT,DEFAULT_FREQ);

   if (~value & 0x08 && Sound & 0x08)
      stopsample(3);

   Sound = value;

}
//shift write
void invportw4(UINT16 offset, UINT8 value, struct z80PortWrite *zpw)
{
   shft2=shft;
   shft=value;
}

//sound
void invportw5(UINT16 offset, UINT8 value, struct z80PortWrite *zpw)
{
   static UINT8 Sound = 0;

   if (value & 0x01 && ~Sound & 0x01)
      playsample(4,4,ONE_SHOT,DEFAULT_FREQ);

   if (value & 0x02 && ~Sound & 0x02)
      playsample(5,5,ONE_SHOT,DEFAULT_FREQ);

   if (value & 0x04 && ~Sound & 0x04)
      playsample(6,6,ONE_SHOT,DEFAULT_FREQ);

   if (value & 0x08 && ~Sound & 0x08)
      playsample(7,7,ONE_SHOT,DEFAULT_FREQ);

   if (value & 0x10 && ~Sound & 0x10)
      playsample(8,8,ONE_SHOT,DEFAULT_FREQ);

   if (~value & 0x10 && Sound & 0x10)
      stopsample(5);


   invflipw(value&0x20);

   Sound = value;

}

void invportw6(UINT16 offset, UINT8 value, struct z80PortWrite *zpw)
{
}

UINT16 invportr0(UINT16 offset, struct z80PortRead *zpr)
{
   return 0xf4;
}

UINT16 invrvportr0(UINT16 offset, struct z80PortRead *zpr)
{
   return rvpt0;
}

//inputs
UINT16 invportr1(UINT16 offset, struct z80PortRead *zpr)
{

   return pCode[0x10001];
}


//shift read
UINT16 invportr3(UINT16 offset, struct z80PortRead *zpr)
{
   return ((((shft<<8)|shft2)<<shftamnt)>>8)&0xff;
}


void invsetpal(pBYTE pIn)
{

   setstdpal();
   outportb(0x3c8,2);
   outportb(0x3c9,0);
   outportb(0x3c9,COLVAL);
   outportb(0x3c9,0);

   outportb(0x3c8,4);
   outportb(0x3c9,COLVAL);
   outportb(0x3c9,0);
   outportb(0x3c9,0);

   outportb(0x3c8,14);
   outportb(0x3c9,COLVAL);
   outportb(0x3c9,COLVAL);
   outportb(0x3c9,0);

}
