#include "main.h"
#include "pacvid.h"
#include "globals.h"
#include "twk.h"
static BYTE clookup[128];
BYTE pacvram[2048];
static BYTE paccram[2048];
int pacidx1;
int pacidxbase1;
int pacidx2;
int pacbank;
static int pacintvect=0xff;
static int pacintenable=1;
static int counter=0;
static int pacspeed=0;

void pacintenablew(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   pacintenable=value&1;
}

void initpac(void)
{
   pacidx1=0x4ffe;
   pacidxbase1=0x4ff0;
   pacidx2=0x506e;
   pacbank=0;
   checkspeed();
}

void inittheglob(void)
{

	/* While the PAL supports up to 16 decryption methods, only four
		are actually used in the PAL.  Therefore, we'll take a little
		memory overhead and decrypt the ROMs using each method in advance. */
	theglob_decrypt_rom_8();
	theglob_decrypt_rom_9();
	theglob_decrypt_rom_A();
	theglob_decrypt_rom_B();

	/* The initial state of the counter is 0x0A */
	counter = 0x0A;
   setbasecode(0x18000);
   initpac();
}

void initeyes(void)
{
   pacidx1=0x4ffe;
   pacidxbase1=0x4ff0;
   pacidx2=0x506e;
   pacbank=0;
   eyesdecode();
   checkspeed();
}


void initpacplus(void)
{
   pacidx1=0x4ffe;
   pacidxbase1=0x4ff0;
   pacidx2=0x506e;
   pacbank=0;
   pacplusdecode();
   checkspeed();
}

void clearpac(void)
{
}


void pacvideowrite(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   int work;
   WRITE_MEM;
   work=offset-mwb->lowAddr;
   pacvram[work]=value;
}


void pacintvw(UINT16 offset, UINT8 value, struct z80PortWrite *zpw)
{
   static int lastvect;
   pacintvect=value;
   if(value!=lastvect)
      mz80ClearPendingInterrupt();
   lastvect=value;
}

void paccolwrite(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   int work;
   WRITE_MEM;
   work=offset-mwb->lowAddr;
   paccram[work]=value;
}




void vanvanint(void)
{
   if(pCode[0x5000])
      mz80nmi();
}

void pacint(void)
{
   static int cheaton=FALSE;
   struct MemoryReadByte mrb;


   if(pacspeed)
   {
      if(dip4(0x10000,&mrb)==1)
      {
         if(!cheaton)
         {
            pCode[0x180b]=0x01;
            pCode[0x1ffd]=0xbd;
            cheaton=TRUE;
         }
      }
      else
      {
         if(cheaton)
         {
            pCode[0x180b]=0xbe;
            pCode[0x1ffd]=0x00;
            cheaton=FALSE;
         }
      }
   }

   mz80int(pacintvect);
}

void dreamint(void)
{
   if(pacintenable)
      mz80nmi();
}

void pacsetpal(pBYTE pIn)
{
   int idx,inner;
   int bit0,bit1,bit2;


   for(idx=0;idx<16;idx++)
   {
      outportb(0x3c8,idx);
//red
      bit0=(*pIn&1)*0x21;
      bit1=((*pIn>>1)&1)*0x47;
      bit2=((*pIn>>2)&1)*0x97;
      outportb(0x3c9,(bit0+bit1+bit2)>>2);
//green
      bit0=((*pIn>>3)&1)*0x21;
      bit1=((*pIn>>4)&1)*0x47;
      bit2=((*pIn>>5)&01)*0x97;
      outportb(0x3c9,(bit0+bit1+bit2)>>2);
//blue
      bit0=0;
      bit1=((*pIn>>6)&1)*0x47;
      bit2=((*pIn>>7)&1)*0x97;
      outportb(0x3c9,(bit0+bit1+bit2)>>2);
      pIn++;
	}
   pIn+=16;
   for(idx=0;idx<128;idx++)
      collookups[0][idx]=*(pIn++)&0x0f;

}

void pacupdatescreen(void)
{
   drawpacchars();
   drawpacsprites();
}

void vanvandatescreen(void)
{
   FlipScreen=!FlipScreen;
   drawpacchars();
   FlipScreen=!FlipScreen;

   flipxy=!flipxy;
   ror=!ror;
   drawpacsprites();
   flipxy=!flipxy;
   ror=!ror;

}


void drawpacchars(void)
{
   int y,x,prey1,prey2,prey3,xoff;
   pBYTE pWork1;
   pBYTE pWork2;
   pBYTE pWork3;
   pBYTE pWork4;

   if(realorient)
   {
      if(FlipScreen)
      {
         for(y=2;y<30;y++)
         {
            prey2=y<<5;
            pWork1=&pacvram[prey2];
            pWork2=&paccram[prey2];
            prey1=y<<3;
            for(x=0;x<32;x++,pWork1++,pWork2++)
               dispchar(280-((x+2)<<3),248-prey1,(*pWork1)+(pacbank<<8),*pWork2&0x1f);
         }
         for(y=0;y<2;y++)
         {
            prey1=(y+30)<<5;
            prey2=y<<5;
            pWork1=&pacvram[prey1];
            pWork2=&paccram[prey1];
            pWork3=&pacvram[prey2];
            pWork4=&paccram[prey2];

            for(x=0;x<32;x++,pWork1++,pWork2++,pWork3++,pWork4++)
            {
               dispchar((35-y)<<3,248-(x<<3),(*pWork1)+(pacbank<<8),*pWork2&0x1f);
               dispchar((1-y)<<3,248-(x<<3),(*pWork3)+(pacbank<<8),*pWork4&0x1f);
            }
         }
      }
      else
      {
         for(y=2;y<30;y++)
         {
            prey2=y<<5;
            pWork1=&pacvram[prey2];
            pWork2=&paccram[prey2];
            prey1=y<<3;
            for(x=0;x<32;x++,pWork1++,pWork2++)
               dispchar((x+2)<<3,prey1,(*pWork1)+(pacbank<<8)+(pacbank<<8),*pWork2&0x1f);
         }
         for(y=0;y<2;y++)
         {
            prey1=(y+30)<<5;
            prey2=y<<5;
            pWork1=&pacvram[prey1];
            pWork2=&paccram[prey1];
            pWork3=&pacvram[prey2];
            pWork4=&paccram[prey2];

            for(x=0;x<32;x++,pWork1++,pWork2++,pWork3++,pWork4++)
            {
               dispchar(y<<3,x<<3,(*pWork1)+(pacbank<<8),*pWork2&0x1f);
               dispchar((y+34)<<3,x<<3,(*pWork3)+(pacbank<<8),*pWork4&0x1f);
            }
         }
      }
   }
   else
   {
      if(FlipScreen)
      {
         for(y=2;y<30;y++)
         {
            prey1=(y<<3)+7;
            prey2=y<<5;
            prey3=(31-y);
            pWork1=&pacvram[prey2];
            pWork2=&paccram[prey2];
            for(x=0;x<32;x++,pWork1++,pWork2++)
               dispchar(prey1,264-(x<<3),(*pWork1)+(pacbank<<8),*pWork2&0x1f);
         }
         for(y=0;y<2;y++)
         {
            prey1=(y+30)<<5;
            prey2=y<<5;
            prey3=(35-y)<<3;
            pWork1=&pacvram[prey1];
            pWork2=&paccram[prey1];
            pWork3=&pacvram[prey2];
            pWork4=&paccram[prey2];

            for(x=0;x<32;x++,pWork1++,pWork2++,pWork3++,pWork4++)
            {
               dispchar((x<<3)+7,prey3,(*pWork1)+(pacbank<<8),*pWork2&0x1f);
               dispchar((x<<3)+7,(1-y)<<3,(*pWork3)+(pacbank<<8),*pWork4&0x1f);
            }
         }
      }
      else
      {
         for(y=2;y<30;y++)
         {
            prey1=255-(y<<3);
            prey2=y<<5;
            prey3=(31-y);
            pWork1=&pacvram[prey2];
            pWork2=&paccram[prey2];
            for(x=0;x<32;x++,pWork1++,pWork2++)
               dispchar(prey1,((x+2)<<3),(*pWork1)+(pacbank<<8),*pWork2&0x1f);
         }
         for(y=0;y<2;y++)
         {
            prey1=(y+30)<<5;
            prey2=y<<5;
            prey3=y<<3;
            pWork1=&pacvram[prey1];
            pWork2=&paccram[prey1];
            pWork3=&pacvram[prey2];
            pWork4=&paccram[prey2];

            for(x=0;x<32;x++,pWork1++,pWork2++,pWork3++,pWork4++)
            {
               dispchar(255-(x<<3),prey3,(*pWork1)+(pacbank<<8),*pWork2&0x1f);
               dispchar(255-(x<<3),(y+34)<<3,(*pWork3)+(pacbank<<8),*pWork4&0x1f);
            }
         }
      }
   }
}



void drawpacsprites(void)
{
   int index;
   int index2;
   int x,y;
   BYTE spr,col;

   if(realorient)
   {
      for(index=pacidx1,index2=pacidx2;index>=pacidxbase1;index-=2,index2-=2)
      {

         if(ror)
         {
            x=pCode[index2+1];
            y=255-pCode[index2];
         }
         else
         {
            x=272-pCode[index2+1];
            y=pCode[index2]-15;
         }
         if(y>15&&y<240)
         {
            spr=pCode[index];
            col=pCode[index+1]&0x1f;
            if(ror)
               sprblit(x,y,(spr>>2)+(pacbank<<6),col,!(spr&1),!(spr&2));
            else
               sprblit(x,y,(spr>>2)+(pacbank<<6),col,spr&1,spr&2);
         }
      }
   }
   else
   {
      for(index=pacidx1,index2=pacidx2;index>=pacidxbase1;index-=2,index2-=2)
      {
         if(flipxy)
         {
            y=pCode[index2+1];
            x=pCode[index2]-8;
         }
         else
         {
            y=272-pCode[index2+1];
            x=262-pCode[index2];
         }
         if(x>15&&x<240)
         {
            spr=pCode[index];

            col=pCode[index+1]&0x1f;
            if(flipxy)
               sprblit(x,y,(spr>>2)+(pacbank<<6),col,!(spr&2),!(spr&1));
            else
               sprblit(x,y,(spr>>2)+(pacbank<<6),col,spr&2,spr&1);
         }
      }
   }
}


void markpacdirt(int x,int y)
{
   int idx;

   static int xoff[]={-1,0,1,-1,0,1,-1,0,1};
   static int yoff[]={0,0,0,1,1,1,2,2,2};

   x>>=3;
   y>>=3;

   for(idx=0;idx<9;idx++)
      pacdirty[x+xoff[idx]+((y+yoff[idx])<<5)]=-1;
}

void markpacdirtreal(int x,int y)
{
   int idx;
   static int xoff[]={0,1,2,0,1,2,0,1,2};
   static int yoff[]={0,0,0,1,1,1,2,2,2};

   x>>=3;
   y>>=3;
   for(idx=0;idx<9;idx++)
      pacdirty[x+xoff[idx]+((y+yoff[idx])<<5)]=-1;


}



static unsigned char decrypt1(unsigned char e)
{
	return e;
}

static unsigned char decrypt2(unsigned char e)
{
	unsigned char d;

	d  = ((~e) & 0x80) >> 5;
	d |= ((~e) & 0x40) << 1;
	d |= (e & 0x20) >> 2;
	d |= (e & 0x10) >> 4;
	d |= (e & 0x08) << 2;
	d |= ((~e) & 0x04) << 2;
	d |= (e & 0x02) << 5;
	d |= ((~e) & 0x01) << 1;

	return d;
}

static unsigned char decrypt3(unsigned char e)
{
	unsigned char d;

	d  = (e & 0x80) >> 2;
	d |= ((~e) & 0x40) >> 2;
	d |= ((~e) & 0x20) >> 5;
	d |= (e & 0x10) >> 1;
	d |= ((~e) & 0x08) << 3;
	d |= ((~e) & 0x04) >> 0;
	d |= (e & 0x02) >> 0;
	d |= ((~e) & 0x01) << 7;

	return d;
}

static unsigned char decrypt4(unsigned char e)
{
	unsigned char d;

	d  = (e & 0x80) >> 0;
	d |= (e & 0x40) >> 0;
	d |= ((~e) & 0x20) >> 0;
	d |= (e & 0x10) >> 0;
	d |= ((~e) & 0x08) >> 0;
	d |= (e & 0x04) >> 0;
	d |= (e & 0x02) >> 0;
	d |= (e & 0x01) >> 0;

	return d;
}

static unsigned char decrypt5(unsigned char e)
{
	unsigned char d;

	d  = ((~e) & 0x80) >> 5;
	d |= ((~e) & 0x40) << 1;
	d |= ((~e) & 0x20) >> 0;
	d |= (e & 0x10) >> 4;
	d |= ((~e) & 0x08) >> 0;
	d |= ((~e) & 0x04) << 2;
	d |= (e & 0x02) << 5;
	d |= ((~e) & 0x01) << 1;

	return d;
}

static unsigned char decrypt6(unsigned char e)
{
	unsigned char d;

	d  = ((~e) & 0x80) >> 4;
	d |= ((~e) & 0x40) >> 2;
	d |= ((~e) & 0x20) >> 5;
	d |= (e & 0x10) << 1;
	d |= ((~e) & 0x08) << 3;
	d |= ((~e) & 0x04) >> 0;
	d |= (e & 0x02) >> 0;
	d |= ((~e) & 0x01) << 7;

	return d;
}

static unsigned char decrypt(int addr, unsigned char e)
{
	unsigned int method = 1;

	switch (addr & 0x2A5)
	{
		case 0x001:
		case 0x201:
		case 0x005:
		case 0x025:
		case 0x080:
		case 0x084:
		case 0x085:
		case 0x0A5:
		case 0x2A5:
		case 0x200:
		case 0x221:
		case 0x2A1:
			method = 2;
			break;
		case 0x004:
		case 0x204:
		case 0x020:
		case 0x220:
		case 0x024:
		case 0x224:
		case 0x0A0:
		case 0x2A0:
		case 0x0A4:
		case 0x2A4:
		case 0x281:
		case 0x285:
			method = 3;
			break;
	}

	if ((addr & 0x800) == 0x800)
		method = method + 3;

	switch (method)
	{
		case 1:		return decrypt1(e);
		case 2:		return decrypt2(e);
		case 3:		return decrypt3(e);
		case 4:		return decrypt4(e);
		case 5:		return decrypt5(e);
		case 6:		return decrypt6(e);
	}

	return 0;
}


void pacplusdecode(void)
{
	int i;

   for(i=0;i<0x4000;i++)
      pBaseCode[0][i]=decrypt(i,pBaseCode[0][i]);
}

static void eyesdecodedata(pBYTE data)
{
	int j;
   BYTE swapbuffer[8];

   for(j=0;j<8;j++)
		swapbuffer[j] = data[(j >> 2) + (j & 2) + ((j & 1) << 2)];

   for(j=0;j<8;j++)
	{
      BYTE ch=swapbuffer[j];
      data[j]=(ch&0x80)|((ch&0x10)<<2)|(ch&0x20)|((ch&0x40)>>2)|(ch&0x0f);
	}
}

void eyesdecode(void)
{
	int i;

   for(i=0;i<0x4000;i++)
      pCode[i]=(pCode[i]&0xc0)|((pCode[i]&0x08)<<2)|(pCode[i]&0x10)|((pCode[i]&0x20)>>2)|(pCode[i]&0x07);

}

void eyesdecodegfx(pBYTE pIn,int nType)
{
   int idx;
   PRECALC_RETURN
   for(idx=0;idx<0x2000;idx+=8)
      eyesdecodedata(&pIn[idx]);
}


void checkspeed(void)
{
   if((pCode[0x180b]==0xbe&&pCode[0x1ffd]==0x00)||
         (pCode[0x180b]==0x01&&pCode[0x1ffd]==0xbd))
      pacspeed=1;
	else
      pacspeed=0;
}

void theglob_decrypt_rom_8(void)
{
	int oldbyte,inverted_oldbyte,newbyte;
	int mem;



	for (mem=0;mem<0x4000;mem++)
	{
      oldbyte = pCode[mem];
		inverted_oldbyte = ~oldbyte;

		/*	Note: D2 is inverted and connected to D1, D5 is inverted and
			connected to D0.  The other six data bits are converted by a
			PAL10H8 driven by the counter. */
		newbyte = 0;

		/* Direct inversion */
		newbyte  = (inverted_oldbyte & 0x04) >> 1;
		newbyte |= (inverted_oldbyte & 0x20) >> 5;
		/* PAL */
		newbyte |= (oldbyte & 0x01) << 5;
		newbyte |= (oldbyte & 0x02) << 1;
		newbyte |= (inverted_oldbyte & 0x08) << 4;
		newbyte |= (inverted_oldbyte & 0x10) >> 1;
		newbyte |= (inverted_oldbyte & 0x40) >> 2;
		newbyte |= (inverted_oldbyte & 0x80) >> 1;

      pCode[mem + 0x10000] = newbyte;
	}

	return;
}

void theglob_decrypt_rom_9(void)
{
	int oldbyte,inverted_oldbyte,newbyte;
	int mem;


	for (mem=0;mem<0x4000;mem++)
	{
      oldbyte = pCode[mem];
		inverted_oldbyte = ~oldbyte;

		/*	Note: D2 is inverted and connected to D1, D5 is inverted and
			connected to D0.  The other six data bits are converted by a
			PAL10H8 driven by the counter. */
		newbyte = 0;

		/* Direct inversion */
		newbyte  = (inverted_oldbyte & 0x04) >> 1;
		newbyte |= (inverted_oldbyte & 0x20) >> 5;
		/* PAL */
		newbyte |= (oldbyte & 0x01) << 5;
		newbyte |= (inverted_oldbyte & 0x02) << 6;
		newbyte |= (oldbyte & 0x08) << 1;
		newbyte |= (inverted_oldbyte & 0x10) >> 1;
		newbyte |= (inverted_oldbyte & 0x40) >> 4;
		newbyte |= (inverted_oldbyte & 0x80) >> 1;

      pCode[mem + 0x14000] = newbyte;
	}

	return;
}

void theglob_decrypt_rom_A(void)
{
	int oldbyte,inverted_oldbyte,newbyte;
	int mem;

	for (mem=0;mem<0x4000;mem++)
	{
      oldbyte = pCode[mem];
		inverted_oldbyte = ~oldbyte;

		/*	Note: D2 is inverted and connected to D1, D5 is inverted and
			connected to D0.  The other six data bits are converted by a
			PAL10H8 driven by the counter. */
		newbyte = 0;

		/* Direct inversion */
		newbyte  = (inverted_oldbyte & 0x04) >> 1;
		newbyte |= (inverted_oldbyte & 0x20) >> 5;
		/* PAL */
		newbyte |= (inverted_oldbyte & 0x01) << 6;
		newbyte |= (oldbyte & 0x02) << 1;
		newbyte |= (inverted_oldbyte & 0x08) << 4;
		newbyte |= (inverted_oldbyte & 0x10) << 1;
		newbyte |= (inverted_oldbyte & 0x40) >> 2;
		newbyte |= (oldbyte & 0x80) >> 4;

      pCode[mem + 0x18000] = newbyte;
	}

	return;
}

void theglob_decrypt_rom_B(void)
{
	int oldbyte,inverted_oldbyte,newbyte;
	int mem;

	for (mem=0;mem<0x4000;mem++)
	{
      oldbyte = pCode[mem];
		inverted_oldbyte = ~oldbyte;

		/*	Note: D2 is inverted and connected to D1, D5 is inverted and
			connected to D0.  The other six data bits are converted by a
			PAL10H8 driven by the counter. */
		newbyte = 0;

		/* Direct inversion */
		newbyte  = (inverted_oldbyte & 0x04) >> 1;
		newbyte |= (inverted_oldbyte & 0x20) >> 5;
		/* PAL */
		newbyte |= (inverted_oldbyte & 0x01) << 6;
		newbyte |= (inverted_oldbyte & 0x02) << 6;
		newbyte |= (oldbyte & 0x08) << 1;
		newbyte |= (inverted_oldbyte & 0x10) << 1;
		newbyte |= (inverted_oldbyte & 0x40) >> 4;
		newbyte |= (oldbyte & 0x80) >> 4;

      pCode[mem + 0x1C000] = newbyte;
	}

	return;
}


UINT16 theglobdecrypt(UINT16 offset, struct z80PortRead *zpr)
{
	if (offset & 0x01)
	{
		counter = counter - 1;
		if (counter < 0)
			counter = 0x0F;
	}
	else
	{
		counter = (counter + 1) & 0x0F;
	}

	switch(counter)
	{
      case 0x08:
         setbasecode(0x10000);
         break;
      case 0x09:
         setbasecode(0x14000);
         break;
      case 0x0A:
         setbasecode(0x18000);
         break;
      case 0x0B:
         setbasecode(0x1c000);
         break;
	}

	return 0;
}


UINT8 dreamnon(UINT32 offset,struct MemoryReadByte * mrb)
{
   return 0xfe;
}


