#ifndef _SCOBR_MEM_H_
#define _SCOBR_MEM_H_

struct MemoryWriteByte SCobraWrite[] =
{
   {0x0000,0x7fff,romwrite,NULL},
   {0x8c00,0x8fff,romwrite,NULL},
   {0x9080,0x90ff,romwrite,NULL},
   {0xa801,0xa801,scobravw,NULL},
   {0xa803,0xa803,scramback,NULL},
   {0xa807,0xa807,flipscreenw,NULL},
   {0xa000,0xa000,sound_command_w,NULL},
   {0xa001,0xa001,scramsndirq,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct MemoryReadByte SCobraRead[] =
{
   {0x9801,0x9801,dip1,NULL},
   {0x9802,0x9802,dip2,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};


struct MemoryReadByte SCobraSndRead[] =
{
   {(UINT32)0xffffffff,(UINT32)0xfffffff, NULL,NULL}
};

struct MemoryWriteByte SCobraSndWrite[] =
{
   {0x0000,0x0fff,romwrite,NULL},
   {(UINT32)0xffffffff,(UINT32)0xfffffff, NULL,NULL}
};

struct z80PortRead SCobraSndReadPorts[] =
{
   {0x20,0x20,AY8910_read_port_1_r,NULL},
   {0x80,0x80,AY8910_read_port_0_r,NULL},
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};



struct z80PortWrite SCobraSndWritePorts[] =
{
   {0x10,0x10,AY8910_control_port_1_w,NULL},
   {0x20,0x20,AY8910_write_port_1_w,NULL},
   {0x40,0x40,AY8910_control_port_0_w,NULL},
   {0x80,0x80,AY8910_write_port_0_w,NULL},
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};



struct MemoryWriteByte HustlerWrite[] =
{
   {0x0000,0x3fff,romwrite,NULL},
   {0xa804,0xa804,scobravw,NULL},
   {0xa806,0xa806,flipscreenw,NULL},
   {0xa80e,0xa80e,romwrite,NULL},
   {0xe000,0xe000,sound_command_w,NULL},
   {0xe008,0xe008,scramsndirq,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};


struct MemoryReadByte HustlerRead[] =
{
   {0xd008,0xd008,dip1,NULL},
   {0xd010,0xd010,dip2,NULL},
   {(UINT32)0xffffffff,     (UINT32)0xfffffff, NULL,NULL}
};

struct z80PortWrite HustlerSndWritePorts[] =
{
   {0x40,0x40,AY8910_write_port_0_w,NULL},
   {0x80,0x80,AY8910_control_port_0_w,NULL},
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};

struct z80PortRead HustlerSndReadPorts[] =
{
   {0x40,0x40,AY8910_read_port_0_r,NULL},
   {(UINT16)0xffff,     (UINT16)0xffff, NULL,NULL}
};

#endif
