#include "main.h"
#include "globals.h"
#include "scramsnd.h"

extern int pending_commands;

static struct AY8910interface interface =
{
   2,
   1789750,
   { 15,15},
   {0,0},
   { sound_command_r },
   { scramble_portB_r },
   { 0 },
   { 0 }
};

static struct AY8910interface antinterface =
{
   2,
   1789750,
   { 15,15},
   {2,2},
   { sound_command_r },
   { scramble_portB_r },
   { 0 },
   { 0 }
};


static struct AY8910interface triplepinterface =
{
   1,
   1789750,
   { 15 },
   {0},
   {0},
   {0},
   {0},
   {0}
};


static struct AY8910interface calinterface =
{
   2,
   1789750,
   { 15,15},
   {2,2},
   { sound_command_r },
   { scramble_portB_r },
   { 0 },
   { 0 }
};

static int noints=0;

static int scramble_timer[10] =
{
	0x00, 0x10, 0x20, 0x30, 0x40, 0x90, 0xa0, 0xb0, 0xa0, 0xd0
};

void initscramsnd(void)
{
   AY8910_sh_start(&interface);
}

void initanteatersnd(void)
{
   AY8910_sh_start(&antinterface);
}

void inittriplepsnd(void)
{
   AY8910_sh_start(&triplepinterface);
}

void initcalipsosnd(void)
{
   AY8910_sh_start(&calinterface);
}

void scrampre(void)
{
   if(CurrentCPU&&noints)
   {
      context[1].z80intPending=1;
      noints--;
   }
}

int scramble_portB_r(void)
{
   static int last_totalcycles = 0;
   static int clock;

   int current_totalcycles;

   current_totalcycles = getcurrentcycles();


   clock = (clock + (current_totalcycles-last_totalcycles)) % 5120;

   last_totalcycles = current_totalcycles;

   return scramble_timer[clock>>9];

}



void scramsndirq(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
	static int last;

   value&=0x08;

   if(!last&&value)
      noints++;

   last=value;
}



void pooyansndirq(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
	static int last;

   if(!last&&value)
      noints++;

   last = value;
}

void hotshocksndirq(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   noints++;
}
