#include "main.h"
#include "scramvid.h"
#include "galvid.h"
#include "globals.h"
#include "twk.h"
#include "blit.h"
void amddispchars(void);
extern int tempval;
extern pBYTE pChars;
extern int starsblink;
extern int backcolor;
static int setscramback;

int scrambuloff;


void initscram(void)
{
   precalcstars();
   blnkchar=16;
   backcolor=0;
   maxchar=32;
   startchar=0;
   pCharMem=&pCode[0x4800];
   pAttrMem=&pCode[0x5000];
}

UINT8 vidmirror(UINT32 offset,struct MemoryReadByte * mrb)
{
   return pCode[offset-0x400];
}


UINT8 devilnon(UINT32 offset,struct MemoryReadByte * mrb)
{
   return 0xff;
}
void scramback(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   if(backcolor!=(value&1))
   {
      setscramback=TRUE;
      backcolor=(value&1);
   }
}


void triplepmir(UINT32 offset, UINT8 value, struct MemoryWriteByte * mwb)
{
   pCode[offset-0x400]=value;
}

void scramint(void)
{
   static int count=0;

   if (count >= 45)
	{
      count=0;
      starsblink=(starsblink+1)&3;
	}
   count++;
   if(pCode[0x6801])
      mz80nmi();
}

void devilint(void)
{
   if(pCode[0x6802])
      mz80nmi();
}

UINT8 scramprotread(UINT32 offset, struct MemoryReadByte *mrb)
{
   switch (z80pc)
	{
      case 0x00a8:
         return 0xf0;
      case 0x00be:
         return 0xb0;
      case 0x0c1d:
         return 0xf0;
      case 0x0c6a:
         return 0xb0;
      case 0x0ceb:
         return 0x40;
      case 0x0d37:
         return 0x60;
      case 0x1d7e:
         return 0xb0;
	}

   return 0;
}


UINT16 triplep_pip(UINT16 offset, struct z80PortRead *zpr)
{
   if(z80pc==0x015a)
      return 0xff;
   if(z80pc==0x0886)
      return 0x05;
   return 0;
}

UINT16 triplep_pap(UINT16 offset, struct z80PortRead *zpr)
{
   if(z80pc==0x015d)
      return 0x04;
   else
      return 0;
}


void scramupdatescreen(void)
{
   fastclear();
   scramdispchars();
   drawsprites(0x5040,32);
   drawscrambullets(0x5060);
   if(pCode[0x6804])
      drawstars(FALSE,TRUE);
}

void drawscrambullets(int buloffset)
{
   int idx;
   int x,y;

   int off1;
   int off2;

   off1=buloffset+1;
   off2=buloffset+3;

   if(realorient)
   {
      for(idx=0;idx<32;idx+=4)
      {
         if(FlipScreen)
         {
            if(ror)
            {
               x=pCode[off2+idx]+7;
               y=pCode[off1+idx];
            }
            else
            {
               x=(249-pCode[off2+idx]);
               y=pCode[off1+idx];
            }
         }
         else
         {
            if(ror)
            {
               x=pCode[off2+idx]+7;
               y=(255-pCode[off1+idx]);
            }
            else
            {
               x=(249-pCode[off2+idx]);
               y=(255-pCode[off1+idx]);
            }
         }
         if(x&&y)
         {
            x+=32;
            y+=32;
            *(pScreen+x+(y<<9))=3;
         }
      }
   }
   else
   {
      for(idx=0;idx<32;idx+=4)
      {
         if(FlipScreen)
         {
            if(flipxy)
            {
               y=pCode[off2+idx]+7;
               x=265-pCode[off1+idx];
            }
            else
            {
               y=(249-pCode[off2+idx]);
               x=(265-pCode[off1+idx]);
            }
         }
         else
         {
            if(flipxy)
            {
               y=pCode[off2+idx]+6;
               x=pCode[off1+idx]+7;
            }
            else
            {
               y=(249-pCode[off2+idx]);
               x=pCode[off1+idx]+7;
            }
         }

         if(x&&y)
         {
            x+=32;
            y+=32;
            *(pScreen+x+(y<<9))=3;
         }
      }
   }
}

void scrampalupd(void)
{
   if(setscramback)
   {
      if(backcolor)
      {
//set 0 to blue
         outportb(0x3c8,0);
         outportb(0x3c9,0);
         outportb(0x3c9,0);
         outportb(0x3c9,12);
      }
      else
      {
//set 0 to black
         outportb(0x3c8,0);
         outportb(0x3c9,0);
         outportb(0x3c9,0);
         outportb(0x3c9,0);
      }
      setscramback=FALSE;
   }
}

void initdevilfish(void)
{
	int i;

	/* Address lines are scrambled on the main CPU:

		A0 -> A2
		A1 -> A0
		A2 -> A3
		A3 -> A1 */


	for (i = 0; i < 0x10000; i += 16)
	{
		int j;
		unsigned char swapbuffer[16];

		for (j = 0; j < 16; j++)
		{
         swapbuffer[j] = pCode[i + ((j & 1) << 2) + ((j & 2) >> 1) + ((j & 4) << 1) + ((j & 8) >> 2)];
		}

      memcpy(&pCode[i], swapbuffer, 16);
	}
   initscram();
}
